Attribute VB_Name = "Bigchars"
' 2004 Christof Rue - www.hobby-elektronik.de.vu
'Die Verwendung dieses Moduls ist ist Freeware, solange diese Zeilen erhalten bleiben!

Public Type BigChar
  Row(0 To 4) As String
End Type
Private RowLength As Long

Function ParseText(Text As String, Optional SmallSpace As Boolean = True) As BigChar
Dim x, y
Dim EachChar As BigChar
Dim BigText As BigChar
For x = 1 To Len(Text)
  With EachChar
  Select Case Asc(Mid(Text, x, 1))
    Case 32: .Row(1) = "99": .Row(2) = "99": .Row(3) = "99": .Row(4) = "99" ' Leerzeichen
    Case 33: .Row(1) = "94": .Row(2) = "98": .Row(3) = "95": .Row(4) = "95" ' !
    Case 34: .Row(1) = "494": .Row(2) = "595": .Row(3) = "999": .Row(4) = "999" ' "
    Case 35: .Row(1) = "494": .Row(2) = "858": .Row(3) = "848": .Row(4) = "595" ' #
    Case 36: .Row(1) = "081": .Row(2) = "889": .Row(3) = "287": .Row(4) = "583" ' $
    Case 37: .Row(1) = "490": .Row(2) = "903": .Row(3) = "039": .Row(4) = "395" ' %
    Case 38: .Row(1) = "041": .Row(2) = "896": .Row(3) = "850": .Row(4) = "252" ' &
    Case 39: .Row(1) = "949": .Row(2) = "989": .Row(3) = "999": .Row(4) = "999" ' '
    Case 40: .Row(1) = "04": .Row(2) = "89": .Row(3) = "89": .Row(4) = "25" ' (
    Case 41: .Row(1) = "41": .Row(2) = "98": .Row(3) = "98": .Row(4) = "53" ' )
    Case 42: .Row(1) = "140": .Row(2) = "989": .Row(3) = "392": .Row(4) = "999" ' *
    Case 43: .Row(1) = "999": .Row(2) = "989": .Row(3) = "585": .Row(4) = "959" ' +
    Case 44: .Row(1) = "9": .Row(2) = "9": .Row(3) = "4": .Row(4) = "3" ' ,
    Case 45: .Row(1) = "999": .Row(2) = "444": .Row(3) = "999": .Row(4) = "999" ' -
    Case 46: .Row(1) = "9": .Row(2) = "9": .Row(3) = "9": .Row(4) = "5" ' .
    Case 47: .Row(1) = "990": .Row(2) = "903": .Row(3) = "039": .Row(4) = "399" ' /
    Case 48: .Row(1) = "041": .Row(2) = "808": .Row(3) = "838": .Row(4) = "253" ' 0
    Case 49: .Row(1) = "049": .Row(2) = "989": .Row(3) = "989": .Row(4) = "555" ' 1
    Case 50: .Row(1) = "041": .Row(2) = "046": .Row(3) = "899": .Row(4) = "555" ' 2
    Case 51: .Row(1) = "041": .Row(2) = "906": .Row(3) = "927": .Row(4) = "253" ' 3
    Case 52: .Row(1) = "499": .Row(2) = "848": .Row(3) = "998": .Row(4) = "995" ' 4
    Case 53: .Row(1) = "444": .Row(2) = "841": .Row(3) = "998": .Row(4) = "253" ' 5
    Case 54: .Row(1) = "041": .Row(2) = "841": .Row(3) = "898": .Row(4) = "253" ' 6
    Case 55: .Row(1) = "444": .Row(2) = "906": .Row(3) = "989": .Row(4) = "959" ' 7
    Case 56: .Row(1) = "041": .Row(2) = "848": .Row(3) = "898": .Row(4) = "253" ' 8
    Case 57: .Row(1) = "041": .Row(2) = "848": .Row(3) = "998": .Row(4) = "253" ' 9
    Case 58: .Row(1) = "9": .Row(2) = "5": .Row(3) = "4": .Row(4) = "9" ' :
    Case 59: .Row(1) = "999": .Row(2) = "959": .Row(3) = "949": .Row(4) = "939" ' ;
    Case 60: .Row(1) = "90": .Row(2) = "03": .Row(3) = "21": .Row(4) = "92" ' <
    Case 61: .Row(1) = "999": .Row(2) = "555": .Row(3) = "444": .Row(4) = "999" ' =
    Case 62: .Row(1) = "19": .Row(2) = "21": .Row(3) = "03": .Row(4) = "39" ' >
    Case 63: .Row(1) = "041": .Row(2) = "906": .Row(3) = "959": .Row(4) = "959" ' ?
    Case 64: .Row(1) = "": .Row(2) = "": .Row(3) = "": .Row(4) = "" ' @
    Case 65, 97: .Row(1) = "041": .Row(2) = "898": .Row(3) = "858": .Row(4) = "595" ' Aa
    Case 66, 98: .Row(1) = "441": .Row(2) = "846": .Row(3) = "897": .Row(4) = "553" ' Bb
    Case 67, 99: .Row(1) = "041": .Row(2) = "895": .Row(3) = "894": .Row(4) = "253" ' Cc
    Case 68, 100: .Row(1) = "441": .Row(2) = "898": .Row(3) = "898": .Row(4) = "553" ' Dd
    Case 69, 101: .Row(1) = "444": .Row(2) = "849": .Row(3) = "899": .Row(4) = "555" ' Ee
    Case 70, 102: .Row(1) = "444": .Row(2) = "849": .Row(3) = "899": .Row(4) = "599" ' Ff
    Case 71, 103: .Row(1) = "041": .Row(2) = "899": .Row(3) = "828": .Row(4) = "253" ' Gg
    Case 72, 104: .Row(1) = "494": .Row(2) = "848": .Row(3) = "898": .Row(4) = "595" ' Hh
    Case 73, 105: .Row(1) = "444": .Row(2) = "989": .Row(3) = "989": .Row(4) = "555" ' Ii
    Case 74, 106: .Row(1) = "444": .Row(2) = "998": .Row(3) = "498": .Row(4) = "253" ' Jj
    Case 75, 107: .Row(1) = "494": .Row(2) = "806": .Row(3) = "827": .Row(4) = "595" ' Kk
    Case 76, 108: .Row(1) = "499": .Row(2) = "899": .Row(3) = "899": .Row(4) = "555" ' Ll
    Case 77, 109: .Row(1) = "190": .Row(2) = "888": .Row(3) = "898": .Row(4) = "595" ' Mm
    Case 78, 110: .Row(1) = "494": .Row(2) = "818": .Row(3) = "828": .Row(4) = "595" ' Nn
    Case 79, 111: .Row(1) = "041": .Row(2) = "898": .Row(3) = "898": .Row(4) = "253" ' Oo
    Case 80, 112: .Row(1) = "441": .Row(2) = "898": .Row(3) = "853": .Row(4) = "599" ' Pp
    Case 81, 113: .Row(1) = "041": .Row(2) = "898": .Row(3) = "808": .Row(4) = "255" ' Qq
    Case 82, 114: .Row(1) = "441": .Row(2) = "846": .Row(3) = "827": .Row(4) = "595" ' Rr
    Case 83, 115: .Row(1) = "041": .Row(2) = "841": .Row(3) = "998": .Row(4) = "253" ' Ss
    Case 84, 116: .Row(1) = "444": .Row(2) = "989": .Row(3) = "989": .Row(4) = "959" ' Tt
    Case 85, 117: .Row(1) = "494": .Row(2) = "898": .Row(3) = "898": .Row(4) = "255" ' Uu
    Case 86, 118: .Row(1) = "494": .Row(2) = "898": .Row(3) = "806": .Row(4) = "239" ' Vv
    Case 87, 119: .Row(1) = "494": .Row(2) = "898": .Row(3) = "888": .Row(4) = "392" ' Ww
    Case 88, 120: .Row(1) = "494": .Row(2) = "243": .Row(3) = "051": .Row(4) = "595" ' Xx
    Case 89, 121: .Row(1) = "494": .Row(2) = "243": .Row(3) = "989": .Row(4) = "959" ' Yy
    Case 90, 122: .Row(1) = "444": .Row(2) = "906": .Row(3) = "069": .Row(4) = "555" ' Zz
    Case 91: .Row(1) = "44": .Row(2) = "89": .Row(3) = "89": .Row(4) = "55" ' [
    Case 92: .Row(1) = "199": .Row(2) = "219": .Row(3) = "921": .Row(4) = "992" ' \
    Case 93: .Row(1) = "44": .Row(2) = "98": .Row(3) = "98": .Row(4) = "55" ' ]
    Case 94: .Row(1) = "01": .Row(2) = "32": .Row(3) = "99": .Row(4) = "99" ' ^
    Case 95: .Row(1) = "999": .Row(2) = "999": .Row(3) = "999": .Row(4) = "555" ' "_"
    Case 123: .Row(1) = "944": .Row(2) = "089": .Row(3) = "289": .Row(4) = "955" ' {
    Case 124: .Row(1) = "4": .Row(2) = "8": .Row(3) = "8": .Row(4) = "5" ' |
    Case 125: .Row(1) = "449": .Row(2) = "981": .Row(3) = "983": .Row(4) = "559" ' }
    Case 126: .Row(1) = "010": .Row(2) = "323": .Row(3) = "999": .Row(4) = "999" ' ~
    Case 128: .Row(1) = "041": .Row(2) = "841": .Row(3) = "859": .Row(4) = "253" ' 
    Case 176: .Row(1) = "01": .Row(2) = "23": .Row(3) = "99": .Row(4) = "99" ' 
    Case 196, 228: .Row(1) = "494": .Row(2) = "041": .Row(3) = "848": .Row(4) = "595" ' 
    Case 214, 246: .Row(1) = "494": .Row(2) = "041": .Row(3) = "898": .Row(4) = "253" ' 
    Case 220, 252: .Row(1) = "999": .Row(2) = "999": .Row(3) = "999": .Row(4) = "999" ' 

  End Select
  End With
  If SmallSpace = True Then
    For y = 1 To 4
      BigText.Row(y) = BigText.Row(y) & EachChar.Row(y) & "9"
    Next
  Else
    For y = 1 To 4
      BigText.Row(y) = BigText.Row(y) & EachChar.Row(y)
    Next
  End If
Next
ParseText = BigText
End Function

Function Init()
Select Case Lcd.Size
  Case 0 To 5: MsgBox "Dieses Modul kann mit dem verwendeten Display nicht verwendet werden!", vbCritical + vbOKOnly
  Case 6: RowLength = 16
  Case 7: RowLength = 20
  Case 8: RowLength = 27
  Case 9: RowLength = 40
End Select
Dim OwnSymbol As DspOwnSymbol
With OwnSymbol
  .sLine(0) = "00000"
  .sLine(1) = "00000"
  .sLine(2) = "00000"
  .sLine(3) = "00001"
  .sLine(4) = "00011"
  .sLine(5) = "00111"
  .sLine(6) = "01111"
  .sLine(7) = "11111"
    Lcd.DefineChar 0, OwnSymbol
  .sLine(0) = "00000"
  .sLine(1) = "00000"
  .sLine(2) = "00000"
  .sLine(3) = "10000"
  .sLine(4) = "11000"
  .sLine(5) = "11100"
  .sLine(6) = "11110"
  .sLine(7) = "11111"
    Lcd.DefineChar 1, OwnSymbol
  .sLine(0) = "11111"
  .sLine(1) = "01111"
  .sLine(2) = "00111"
  .sLine(3) = "00011"
  .sLine(4) = "00001"
  .sLine(5) = "00000"
  .sLine(6) = "00000"
  .sLine(7) = "00000"
    Lcd.DefineChar 2, OwnSymbol
  .sLine(0) = "11111"
  .sLine(1) = "11110"
  .sLine(2) = "11100"
  .sLine(3) = "11000"
  .sLine(4) = "10000"
  .sLine(5) = "00000"
  .sLine(6) = "00000"
  .sLine(7) = "00000"
    Lcd.DefineChar 3, OwnSymbol
  .sLine(0) = "00000"
  .sLine(1) = "00000"
  .sLine(2) = "00000"
  .sLine(3) = "11111"
  .sLine(4) = "11111"
  .sLine(5) = "11111"
  .sLine(6) = "11111"
  .sLine(7) = "11111"
    Lcd.DefineChar 4, OwnSymbol
  .sLine(0) = "11111"
  .sLine(1) = "11111"
  .sLine(2) = "11111"
  .sLine(3) = "11111"
  .sLine(4) = "11111"
  .sLine(5) = "00000"
  .sLine(6) = "00000"
  .sLine(7) = "00000"
    Lcd.DefineChar 5, OwnSymbol
  .sLine(0) = "11111"
  .sLine(1) = "11111"
  .sLine(2) = "11111"
  .sLine(3) = "11111"
  .sLine(4) = "11110"
  .sLine(5) = "11100"
  .sLine(6) = "11000"
  .sLine(7) = "10000"
    Lcd.DefineChar 6, OwnSymbol
  .sLine(0) = "10000"
  .sLine(1) = "11000"
  .sLine(2) = "11100"
  .sLine(3) = "11110"
  .sLine(4) = "11111"
  .sLine(5) = "11111"
  .sLine(6) = "11111"
  .sLine(7) = "11111"
    Lcd.DefineChar 7, OwnSymbol
End With
Lcd.ClearDisplay

End Function

Public Function WriteText(BigLcdText As BigChar)
Dim CurrRow As Long
For CurrRow = 1 To 4
  Lcd.SetPos CurrRow, 1
  For x = 1 To RowLength
   Select Case Mid(BigLcdText.Row(CurrRow), x, 1)
     Case 0 To 7: Lcd.WriteChar Mid(BigLcdText.Row(CurrRow), x, 1)
     Case 8: Lcd.WriteChar 255
     Case 9: Lcd.WriteChar 32
   End Select
  Next x
Next CurrRow
End Function
